package org.openlp.android.common;

import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONStringer;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

/**
 * Created by tim on 01/06/14.
 */
public class JsonHelpers {

    private static String LOG_TAG = JsonHelpers.class.getName();

    public static String createRequestJSON(String key, String value) throws JSONHandlerException {
        try {
            String responseJSON;
            JSONObject jo = new JSONObject();
            jo.put(key, value);
            responseJSON = new JSONStringer().object().key("request").value(jo)
                    .endObject().toString();
            responseJSON = URLEncoder.encode(responseJSON, "UTF-8");
            return responseJSON;
        } catch (JSONException e) {
            throw new JSONHandlerException(e);
        } catch (UnsupportedEncodingException e) {
            throw new JSONHandlerException(e);
        }
    }

    public static class JSONHandlerException extends Exception {
        private static final long serialVersionUID = -6772307308404816615L;

        public JSONHandlerException(Throwable throwable) {
            super(throwable);
        }
    }
}
