package org.openlp.android.common;


import android.app.ListFragment;
import android.content.Context;
import android.os.AsyncTask;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.ListView;
import org.openlp.android.R;

import java.net.MalformedURLException;
import java.net.URISyntaxException;


/**
 * Created by tim on 12/05/14.
 */
abstract public class OpenLPFragment extends ListFragment {

    private final String LOG_TAG = OpenLPHttpClient.class.getName();
    public Context context;

    abstract public void populateDisplay(String results);
    abstract public void itemClicked(int position);

    @Override
    public void onListItemClick(ListView l, View v, int position, long id) {
        super.onListItemClick(l, v, position, id);
        itemClicked(position);
    }

    public class ExecuteHttpRequestTask extends AsyncTask<String, Void, String> {
        @Override
        protected String doInBackground(String... urls) {
            String response = "";
            Log.d(LOG_TAG, "ExecuteHttpRequestTask - entry");
            for (String url : urls) {
                OpenLPHttpClient client = new OpenLPHttpClient(context);
                try {
                    client.setUrl(url);
                } catch (URISyntaxException e) {
                    e.printStackTrace();
                } catch (MalformedURLException e) {
                    e.printStackTrace();
                }
                response = client.runUrl();
            }
            Log.d(LOG_TAG, "ExecuteHttpRequestTask - exit");
            return response;
        }

        @Override
        protected void onPostExecute(String result) {
            populateDisplay(result);
        }
    }
}
