package org.openlp.android.fragments;

import android.content.Context;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.*;
import android.widget.*;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.openlp.android.R;
import org.openlp.android.api.Api;
import org.openlp.android.common.JsonHelpers;
import org.openlp.android.common.OpenLPFragment;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;


public class LiveListFragment extends OpenLPFragment {
    private final String LOG_TAG = ServiceListFragment.class.getName();

    public LiveListFragment() {
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        context = getActivity();
        // create ContextThemeWrapper from the original Activity Context with the custom theme
        //final Context contextThemeWrapper = new ContextThemeWrapper(getActivity(), R.style.OpenLPFullScreen);
        // clone the inflater using the ContextThemeWrapper
        //inflater.cloneInContext(contextThemeWrapper);
        //val v = inflater.inflate(R.layout.detail_fragment, container, false)
        //v.setBackgroundColor(0x557B68EE);
        //getView().setBackgroundResource(R.drawable.openlp_logo_android);
        return super.onCreateView(inflater, container, savedInstanceState);
    }

    @Override
    public void populateDisplay(String json) {
        Log.i(LOG_TAG, "populate_display - entry");
        List<HashMap<String, String>> aList = new ArrayList<HashMap<String, String>>();
        try {
            JSONArray items = new JSONObject(json).getJSONObject("results").getJSONArray("slides");

            for (int i = 0; i < items.length(); ++i) {
                JSONObject item = items.getJSONObject(i);

                HashMap<String, String> hm = new HashMap<String, String>();
                hm.put("tag", item.getString("tag"));
                if (item.getString("selected").equals("true")) {
                    hm.put("title1", Html.fromHtml(item.getString("html")).toString());
                }else {
                    hm.put("title2", Html.fromHtml(item.getString("html")).toString());
                }
                aList.add(hm);
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
        // Keys used in Hashmap
        String[] from = {"tag", "title1", "title2"};

        // Ids of views in live_list_fragment                                            s
        int[] to = {R.id.tag, R.id.title1, R.id.title2};

        // Instantiating an adapter to store each items
        ListAdapter adapter = new SimpleAdapter(getActivity().getBaseContext(), aList,
                R.layout.live_list_fragment, from, to);
        setListAdapter(adapter);
        Log.i(LOG_TAG, "populate_display - exit");
    }

    @Override
    public void onResume() {
        super.onResume();
        Log.d(LOG_TAG, "Resuming...");
        triggerRequest(Api.LIVE_TEXT);
        Log.d(LOG_TAG, "Resumed...");
    }

    private void triggerRequest(String url){
        ExecuteHttpRequestTask task = new ExecuteHttpRequestTask();
        task.execute(new String[]{url});
    }

    public void itemClicked(int position){
        try {
            String request = JsonHelpers.createRequestJSON("id", Integer.toString(position));
            triggerRequest(String.format("%s%s", Api.LIVE_SET, request));
            String message = String.format("Setting list data. apiBase(%s), position(%s)",
                    Api.LIVE_SET, position);
            Log.d(LOG_TAG, message);
            Toast.makeText(getActivity().getBaseContext(), "Display Item selected", Toast.LENGTH_SHORT).show();
        } catch (JsonHelpers.JSONHandlerException e) {
            e.printStackTrace();
            Toast.makeText(getActivity().getBaseContext(), "Request Failed", Toast.LENGTH_SHORT).show();
        }
        triggerRequest(Api.LIVE_TEXT);
    }
}