package org.openlp.android.fragments;

import android.app.Fragment;
import android.net.http.SslError;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.webkit.SslErrorHandler;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import org.openlp.android.R;
import org.openlp.android.common.OpenLPHttpClient;

/**
 * Created by tim on 01/06/14.
 */
public class WebFragment extends Fragment {

    protected String curURL;
    private OpenLPHttpClient httpClient;
    private WebView webview;

    public WebFragment(){
        super();
    }


    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,Bundle savedInstanceState) {
        httpClient = new OpenLPHttpClient(getActivity());
        View view = inflater.inflate(R.layout.web_fragment, container, false);

        if (curURL != null) {
            webview = (WebView) view.findViewById(R.id.webPage);
            webview.getSettings().setJavaScriptEnabled(true);
            webview.getSettings().setBuiltInZoomControls(true);
            webview.getSettings().setLoadWithOverviewMode(true);
            webview.getSettings().setUseWideViewPort(true);
            webview.setScrollBarStyle(WebView.SCROLLBARS_OUTSIDE_OVERLAY);
            webview.setScrollbarFadingEnabled(true);
            webview.setWebViewClient(new webClient());
            webview.loadUrl(String.format("%s%s", httpClient.getUrlBase(), curURL));
        }
        return view;
    }

    @Override
    public void onDestroyView() {
        if (webview != null) {
            webview.destroy();
        }
        super.onDestroyView();
    }

    private class webClient extends WebViewClient {
        @Override
        public boolean shouldOverrideUrlLoading(WebView view, String url) {
            return false;
        }
    }
}
